/*Ŀ
   Filename:screen.h:-  Contains screen functions for C.  Dated:1997 Jan 1     
                                                                           
    Contains the following functions:                                      
                                                                           
        1.initcur()     2.cursoroff()   3.cursoron()                       
        4.hline1(int x1,int y1,int x2)  5.hline2(int x1,int y1,int x2)     
        6.vline1(int x1,int y1,int y2)  7.vline2(int x1,int y1,int y2)     
        8.box1(int x1,int y1,int x2,int y2)                                
        9.box2(int x1,int y1,int x2,int y2)                                
        10.box3(int x1,int y1,int x2,int y2)                               
        11.box4(int x1,int y1,int x2,int y2)                               
        12.boxw(int x1,int y1,int x2,int y2)                               
        13.clear(int x1,int y1,int x2,int y2,int xdelay,int ydelay)        
        14.fill(int asci,int x1,int y1,int x2,int y2,int xdelay,int ydelay)
        15.bigword(int x,int y,char word[10],int asci,int size)            
  */

# include <conio.h>
# include <dos.h>
# include <string.h>

static int cursorstart=-1,cursorend=-1;

static void initcur() /* saves the initial cursor character's starting and ending lines*/
{
  union REGS r;
  if (cursorstart==-1&&cursorend==-1)
   {
     r.h.ah=3;
     r.h.bh=0;
     int86(0x10,&r,&r);
     cursorstart=r.h.ch;
     cursorend=r.h.cl;
   }
 }

void cursoroff()    /* set the cursor character off */
{
  union REGS r;
  initcur();
  r.h.ah=1;
  r.x.cx=0x2000;
  int86(0x10,&r,&r);
}

void cursoron()     /* set the cursor character on */
{
  union REGS r;
  initcur();
  r.h.ah=1;
  r.h.ch=cursorstart;
  r.h.cl=cursorend;
  int86(0x10,&r,&r);
}
/*............To draw a horozontal single line........*/

hline1(int x1,int y1,int x2)
{
 int i;
 for(i=x1;i<=x2;i++){
     gotoxy(i,y1);
     printf("%c",196);
     }
}
/*............To draw a horozontal double line........*/

hline2(int x1,int y1,int x2)
{
 int i;
 for(i=x1;i<=x2;i++){
     gotoxy(i,y1);
     printf("%c",205);
     }
}
/*............To draw a vertical single line........*/

vline1(int x1,int y1,int y2)
{
 int i;
 for(i=y1;i<=y2;i++){
     gotoxy(x1,i);
     printf("%c",179);
     }
}
/*............To draw a vertical double line........*/

vline2(int x1,int y1,int y2)
{
 int i;
 for(i=y1;i<=y2;i++){
     gotoxy(x1,i);
     printf("%c",186);
     }
}
/*............To draw a single lined box.............*/

box1(int x1,int y1,int x2,int y2)
{
  int i;
	x1=x1-1;x2+=1;y1=y1-1;y2+=1;
   gotoxy(x1,y1);cprintf("%c",218);
   gotoxy(x1,y2);cprintf("%c",192);
   gotoxy(x2,y1);cprintf("%c",191);
   gotoxy(x2,y2);cprintf("%c",217);
   for (i=y1+1;i<y2;i++)
   {
	  gotoxy(x1,i);cprintf("%c",179);
	  gotoxy(x2,i);cprintf("%c",179);
   }
   for (x1=x1+1;x1<x2;x1++)
   {
	  gotoxy(x1,y1);cprintf("%c",196);
	  gotoxy(x1,y2);cprintf("%c",196);
   }
}

/*..............To draw a double lined box..............*/

box2(int x1,int y1,int x2,int y2)
{
  int i;
	x1=x1-1;x2+=1;y1=y1-1;y2+=1;
   gotoxy(x1,y1);cprintf("%c",201);
   gotoxy(x1,y2);cprintf("%c",200);
   gotoxy(x2,y1);cprintf("%c",187);
   gotoxy(x2,y2);cprintf("%c",188);
   for (i=y1+1;i<y2;i++)
   {
	  gotoxy(x1,i);cprintf("%c",186);
	  gotoxy(x2,i);cprintf("%c",186);
   }
   for (x1=x1+1;x1<x2;x1++)
   {
	  gotoxy(x1,y1);cprintf("%c",205);
	  gotoxy(x1,y2);cprintf("%c",205);
   }
}

/*..........To draw a box with single sidelines........*/

box3(int x19,int y1,int x2,int y2)
{
  int i;
	x1=x1-1;x2+=1;y1=y1-1;y2+=1;
   gotoxy(x1,y1);cprintf("%c",213);
   gotoxy(x1,y2);cprintf("%c",212);
   gotoxy(x2,y1);cprintf("%c",184);
   gotoxy(x2,y2);cprintf("%c",190);
   for (i=y1+1;i<y2;i++)
   {
	  gotoxy(x1,i);cprintf("%c",179);
	  gotoxy(x2,i);cprintf("%c",179);
   }
   for (x1=x1+1;x1<x2;x1++)
   {
	  gotoxy(x1,y1);cprintf("%c",205);
	  gotoxy(x1,y2);cprintf("%c",205);
   }
}

/*............To draw a box with double sidelines............*/
box4(int x1,int y1,int x2,int y2)
{
  int i;
	x1=x1-1;x2+=1;y1=y1-1;y2+=1;
   gotoxy(x1,y1);cprintf("%c",214);
   gotoxy(x1,y2);cprintf("%c",211);
   gotoxy(x2,y1);cprintf("%c",183);
   gotoxy(x2,y2);cprintf("%c",189);
   for (i=y1+1;i<y2;i++)
   {
	  gotoxy(x1,i);cprintf("%c",186);
	  gotoxy(x2,i);cprintf("%c",186);
   }
   for (x1=x1+1;x1<x2;x1++)
   {
	  gotoxy(x1,y1);cprintf("%c",196);
	  gotoxy(x1,y2);cprintf("%c",196);
   }
}

/*..............To draw a thick white lined box..............*/
boxw(int x1,int y1,int x2,int y2)
{
  int i;
	x1=x1-1;x2+=1;y1=y1-1;y2+=1;
   gotoxy(x1,y1);cprintf("%c%c",219,223);
   gotoxy(x1,y2);cprintf("%c%c",219,220);
   gotoxy(x2,y1);cprintf("%c%c",223,219);
   gotoxy(x2,y2);cprintf("%c%c",220,219);
   for (i=y1+1;i<y2;i++)
   {
	  gotoxy(x1,i);cprintf("%c",219);
	  gotoxy(x2,i);cprintf("%c",219);
   }
   for (x1=x1+1;x1<x2;x1++)
   {
	  gotoxy(x1,y1);cprintf("%c",223);
	  gotoxy(x1,y2);cprintf("%c",220);
   }
}
/*.........Clears a rectangular area in screen.......*/

clear(int x1,int y1,int x2,int y2,int xdelay,int ydelay)
{
 int i,a,j;
 gotoxy(x1,y1);
 a=x1;
 for(j=y1;j<=y2;j++){
     for(i=x1;i<=x2;i++){
	 printf(" ");
	 delay(xdelay);}
     y1++;
     printf("\n");
     delay(ydelay);
     gotoxy(a,y1);      }
}

/*.........Fills a rectangular area with `asci' character.........*/
fill(int asci,int x1,int y1,int x2,int y2,int xdelay,int ydelay)
{
 int i,a,j;
 gotoxy(x1,y1);
 a=x1;
 for(j=y1;j<=y2;j++){
     for(i=x1;i<=x2;i++){
	 printf("%c",asci);
	 delay(xdelay);}
     y1++;
     printf("\n");
     delay(ydelay);
     gotoxy(a,y1);      }
}

/*-----------------Big word, Coded by Shabeer M----------------------------*/
/*........Converts the given word to a big one drawn with 'asci' character....*/
/*........eg:- bigword(1,1,"Thanks!",220,5);..maximum 8 characters............*/

bigword(int x,int y,char word[10],int asci,int size)
{
  int kk,k,i,j,c,n,row,col,c1;
  int cc=0;
  kk=0;c1=x;col=c1;
  row=y;
 do
 {
 row=y;
  c=word[kk];kk++;

  for (i=0;i<=7;i++) {
      n=128;
  for (j=1;j<=8;j++) {
	k=peekb(0xf000,0xfa6e+c*8+i);
      if ((n & k)) {
	 gotoxy(col,row);
	 for (cc=1;cc<=size;cc++)
	 printf("%c",asci);
	 }
      col=col+size;n=n/2;
      }
    row=row+1;col=c1;
    }
    c1=c1+(8*size)+1;col=c1;
 }
  while (kk<=strlen(word));
}
/*Ŀ
   End of the file "screen.h"            Compiled and edited by Sameer C T 
  */
